image: node:14.17.1-slim
stages:        
  - deploy

# allow caching for faster deployment
cache:
  paths:
    - node_modules/
    - public/
    - .cache/
variables:
  DOCS_FOLDER: "api-docs"
  SPEC_TO_DISPLAY: "swagger.json"

pages:
  stage: deploy
  #  install swaggerUI
  before_script:
  - npm install swagger-ui-dist@3.22.1
  #- npm install swagger-jsdoc --save
  #- npm install swagger-parser --save
  #- npm install --global swagger-jsdoc-generator

  script:
  #  - yarn install
  #  - yarn build:gitlab
  #  - npm install -g apidoc #  install apidoc
    - npm install apidoc-swagger -g
    - mkdir -p public/
  #  - apidoc -i src/ -o public/ #  deploy apidoc
    - mkdir -p public/
    - cp -rp node_modules/swagger-ui-dist/* public/
    - cp  config.json $DOCS_FOLDER
    - cp -rp $DOCS_FOLDER/* public
    - apidoc-swagger -i src/ -o public/
    - sed -i "s#https://petstore\.swagger\.io/v2/swagger\.json#$SPEC_TO_DISPLAY#g" public/index.html
  artifacts:
      paths:
        - public
  rules:
    - if: $CI_COMMIT_BRANCH ==$CI_DEFAULT_BRANCH
 
